/* -*- C -*- */
/* $Id$ */

/**********************************************************************/
/*  Copyright (C) 2007, FUJIWARA Hiroshi                              */
/*        <fujiwara@acs.i.kyoto-u.ac.jp>                              */
/**********************************************************************/

#define PRECISION 100
#include "exfloat.h"
#include <iostream>
#include <complex>
using namespace std;

int main()
{
    complex<exfloat> i = complex<exfloat>(0,1);
    exfloat PI = "#PI";
    complex<exfloat> iPI = i * PI;

    cout << "i = " << i << endl;
    cout << "exp(i*PI) = " << exp(i*PI) << endl;
    cout << "exp(i*PI) = " << exp(iPI) << endl;
    cout << "sqrt(i) = " << sqrt(i) << endl;

    complex<exfloat> x, y, z;

    x = complex<exfloat>(PI,0);
    y = complex<exfloat>(0,"0.2");
    z = complex<exfloat>("#PI","0.5");

    cout << "x = " << x << ' '
	 << "y = " << y << ' '
	 << "z = " << z << endl;

    // Followings are available.
    cout << "x+y = " << x + y << endl;
    cout << "PI+x = " << PI + x << endl;
    cout << "PI*x = "  << PI * x << endl;
    cout << "x*PI = "  << x * PI << endl;
    cout << "i*z = "   << i * z << endl;
    
    // Next is not available.
    // cout << 2*x << endl;

    cout << "Real part of z = " << z.real() << ", "
	 << "Imag part of z = " << z.imag() << endl;

    cout << "z = " << setprecision(50) << z << endl;

    return 0;
}

/* Local Variables: */
/* compile-command: "gcc -O2 -Wall -o " */
/* End: */
