#define PRECISION 100
#include "exfloat.h"
#include <iostream>
using namespace std;

void dump(const double *const d)
{
    const unsigned char *const p = reinterpret_cast<const unsigned char *const >(d);
    for(int i = 7; i >= 0; i--)
	printf("%02x:", p[i]);
    putchar('\n');

    return;
}

int main()
{
    cout << "convert 1" << endl;
    double d = 2.225073e-308;
    exfloat xd = "2.225073e-308";
    double rd = xd;

    cout.precision(32);
    cout << "d=" << d << endl;
    cout << "xd=" << xd << endl;
    cout << "rd=" << rd << endl;

    cout << "minimal normalized number" << endl;
    xd = "@3ffffffffffffc01";
    rd = xd;
    cout << "xd=" << xd << endl;
    cout << "rd=" << rd << endl;
    dump(&rd);

    xd = "@3ffffffffffffc00:fffffffffffff000"; // subnormal number???
    rd = xd;
    cout << "xd=" << xd << endl;
    cout << "rd=" << rd << endl;
    dump(&rd);

    cout << endl;
    cout << "maximal subnormal number" << endl;
    xd = "@3ffffffffffffc00:ffffffffffffe000";
    rd = xd;
    cout << "xd=" << xd << endl;
    cout << "rd=" << rd << endl;
    dump(&rd);

    xd = "@3ffffffffffffc00";
    rd = xd;
    cout << "xd=" << xd << endl;
    cout << "rd=" << rd << endl;
    dump(&rd);

    xd = "@3ffffffffffffbff";
    rd = xd;
    cout << "xd=" << xd << endl;
    cout << "rd=" << rd << endl;
    dump(&rd);

    xd = "@3ffffffffffffbcd"; // 0xc00 - 51 = 0xc00 -0x33 = 0xbcd
    rd = xd;
    cout << "xd=" << xd << endl;
    cout << "rd=" << rd << endl;
    dump(&rd);

    xd = "@3ffffffffffffbcc"; // 0xc00 - 52
    rd = xd;
    cout << "xd=" << xd << endl;
    cout << "rd=" << rd << endl;
    dump(&rd);

    xd = "@3ffffffffffffbcb"; // 0xc00 - 53
    rd = xd;
    cout << "xd=" << xd << endl;
    cout << "rd=" << rd << endl;
    dump(&rd);

    // floating-point number, double type
    //
    // e:  bias = 0x3ff = 1023
    //
    //   bitpattern (biased) | unbiased
    // ----------------------+------------------------------
    //   000 (subnormal)     | -1022
    //   001                 | 1-1023 = -1022
    //   3ff                 | 3ff-3ff = 0
    //   7fe                 | 7fe-3ff = 20o46-1023 = 1023
    //   7ff                 | +infty

    return 0;
}

// End of file
