! -*- f90 -*-
! Time-stamp: "2006-04-12 01:06:43 fujiwara"
! $Id$
!----------------------------------------------------------------------
!  sample of MPI (one-to-one communication) program with exfloat
!
!  Copyright (C) 2006, FUJIWARA Hiroshi
!        <fujiwara@acs.i.kyoto-u.ac.jp>
!----------------------------------------------------------------------

PROGRAM main

    USE exflib
    IMPLICIT NONE
    INCLUDE 'mpif.h'

    INTEGER*4 :: i, s, size

    ! ΥץǤϡΡ 1 Ρ 0 
    INTEGER*4, PARAMETER :: src = 1
    INTEGER*4, PARAMETER :: dst = 0
  
    INTEGER*4, PARAMETER :: N = 10
    TYPE(exfloat) :: x, a(1:N)

    ! ʤ
    INTEGER*4 :: numprocs, mynode
    INTEGER*4 :: ierr, istat(MPI_STATUS_SIZE)
    CALL MPI_INIT(ierr)
    CALL MPI_COMM_SIZE(MPI_COMM_WORLD, numprocs, ierr)
    CALL MPI_COMM_RANK(MPI_COMM_WORLD, mynode, ierr)

    WRITE(*,*) 'ProcID = ', mynode, ' of ', numprocs

    !------------------------------------------------------------
    ! ¿Ĺ 1 Ĥ
    !
    ! (1) 饹 exfloat  num ѿĤ
    ! (2)  exfloat::size 
    ! (3)  MPI::DOUBLE ꤹ
    !------------------------------------------------------------
    x = 100*mynode
    size = exflib_exfloat_size

    ! ͤɽ
    IF ( mynode == dst ) THEN
       WRITE(*,*) exflib_double(x)
    END IF

    ! ¦
    IF( mynode == src ) THEN
       CALL MPI_SEND(x%num(0), size, MPI_REAL8, dst, 1, &
            MPI_COMM_WORLD, ierr)
    END IF

    ! ¦
    IF( mynode == dst ) THEN
       CALL MPI_RECV(x%num(0), size, MPI_REAL8, src, 1, &
            MPI_COMM_WORLD, istat, ierr)
    END IF

    ! ͤɽ
    IF ( mynode == dst ) THEN
       WRITE(*,*) exflib_double(x)
       WRITE(*,*)
    END IF

    !------------------------------------------------------------
    ! ʣ¿Ĺ
    ! buffer Ѱդȹ®Ǥ롣
    !------------------------------------------------------------
    DO i = 1, N
       a(i) = i + mynode*100
    END DO

    ! 
    IF( mynode == src ) THEN
       CALL send(a, N, dst)
    END IF
  
    ! 
    IF( mynode == dst ) THEN
       CALL recv(a, N, src)
    END IF

    ! ͤɽ
    IF ( mynode == dst ) THEN
       DO i = 1, N
          WRITE(*,*) i, exflib_double(a(i))
       END DO
    END IF

    ! λ
    CALL MPI_Finalize(ierr)

  CONTAINS

    !----------------------------------------------------------------------
    ! exfloat  (μؿб)
    ! v  length Ĥ򡢥Ρ dst 
    !----------------------------------------------------------------------
    SUBROUTINE send(v, length, dst_node)
      
      TYPE(exfloat), DIMENSION(1:length), INTENT(IN) :: v
      INTEGER*4, INTENT(IN) :: length, dst_node
      
      INTEGER*8, DIMENSION(:), ALLOCATABLE :: buf
      INTEGER*4 :: bufsize

      INTEGER*4 :: ierr, tag, i

      ! Хåեν
      bufsize = exflib_exfloat_size * length
      ALLOCATE(buf(0:bufsize-1))

      ! packing
      DO i = 1, length
         DO s = 0, exflib_exfloat_size-1
            buf(exflib_exfloat_size*(i-1) + s) = v(i)%num(s)
         END DO
      END DO
      
      ! ǡ
      tag = 1
      CALL MPI_SEND(buf(0), bufsize, MPI_REAL8, dst_node, tag, &
           MPI_COMM_WORLD, ierr)
      
      DEALLOCATE(buf)

    END SUBROUTINE send

    !----------------------------------------------------------------------
    ! exfloat μ (ؿб)
    ! v  length Ĥ򡢥Ρ src 
    !----------------------------------------------------------------------
    SUBROUTINE recv(v, length, src_node)

      TYPE(exfloat), DIMENSION(1:length), INTENT(OUT) :: v
      INTEGER*4, INTENT(IN) :: length, src_node
      
      INTEGER*8, DIMENSION(:), ALLOCATABLE :: buf
      INTEGER*4 :: bufsize

      INTEGER*4 :: ierr, istat(MPI_STATUS_SIZE), tag, i

      ! Хåեν
      bufsize = length * exflib_exfloat_size
      ALLOCATE(buf(0:bufsize-1))

      ! ǡž
      tag = 1
      CALL MPI_RECV(buf(0), bufsize, MPI_REAL8, src_node, tag, &
           MPI_COMM_WORLD, istat, ierr)

      ! unpack
      DO i = 1, length
         DO s = 0, exflib_exfloat_size-1
            v(i)%num(s) = buf(exflib_exfloat_size*(i-1) + s)
         END DO
      END DO
      
      DEALLOCATE(buf)

    END SUBROUTINE recv
    
END PROGRAM main

! End of file
