// -*- C++ -*-
// Time-stamp: "2006-04-11 12:16:52 fujiwara"
// $Id$

//----------------------------------------------------------------------
//  sample of MPI (Broadcast) program with exfloat
//
//  Copyright (C) 2006, FUJIWARA Hiroshi
//        <fujiwara@acs.i.kyoto-u.ac.jp>
//----------------------------------------------------------------------

#define PRECISION 100
#include "exfloat.h"

#include <iostream>
#include "mpi.h"
using namespace std;

//----------------------------------------------------------------------
// exfloat 
// v  length Ĥ򡢥Ρ root Τ
//----------------------------------------------------------------------
void bcast(exfloat *const v, const size_t length, const int root)
{
    const long mynode = MPI::COMM_WORLD.Get_rank();
    const long numprocs = MPI::COMM_WORLD.Get_size();

    // ѤΥХåեѰ
    long size = exfloat::size * length;
    exflib_uQword *buf;
    buf = new exflib_uQword [size];

    // packing
    if(mynode == root)
	for(unsigned int j = 0; j < length; j++)
	    for(int i = 0; i < exfloat::size; i++)
		buf[exfloat::size * j + i] = (v[j]).num[i];

    // communicating
    MPI::COMM_WORLD.Bcast(buf, size, MPI::DOUBLE, root);

    // unpacking
    if(mynode != root)
	for(unsigned int j = 0; j < length; j++)
	    for(int i = 0; i < exfloat::size; i++)
		(v[j]).num[i] = buf[exfloat::size * j + i];
    
    delete [] buf;
    return;
}

//----------------------------------------------------------------------
// main routine
//----------------------------------------------------------------------
int main(int argc, char *argv[])
{
    // ʤ
    MPI::Init(argc, argv);
    const long mynode = MPI::COMM_WORLD.Get_rank();
    const long numprocs = MPI::COMM_WORLD.Get_size();

    // 줾ΥΡɤǤν
    const long N = 10;
    exfloat a[N];
    for(long i = 0; i < N; i++)
        a[i] = i + mynode*100;

    // Ρ 1 Ƥ¾Ρɤ˥֥ɥ㥹Ȥ
    const long root = 1;

    bcast(a, N, root);

    // 㤨СΡ 0 ǼƤɽ
    if(mynode == 0)
	for(long i = 0; i < N; i++)
	    cout << i << ' ' << a[i] << endl;

    return 0;
}

// End of file
