! -*- f90 -*-
! Time-stamp: "2006-04-11 12:18:49 fujiwara"
! $Id$

!----------------------------------------------------------------------
!  sample of MPI (Broadcast) program with exfloat
!
!  Copyright (C) 2006, FUJIWARA Hiroshi
!        <fujiwara@acs.i.kyoto-u.ac.jp>
!----------------------------------------------------------------------

PROGRAM main

    USE exflib
    IMPLICIT NONE
    INCLUDE 'mpif.h'

    ! ΥץǤϡΡ 1 ¾Ρɤ
    INTEGER*4, PARAMETER :: root = 1
  
    INTEGER*4, PARAMETER :: N = 10
    TYPE(exfloat) :: a(1:N)

    INTEGER*4 :: numprocs, mynode, ierr, i
    
    ! ʤ
    CALL MPI_INIT(ierr)
    CALL MPI_COMM_SIZE(MPI_COMM_WORLD, numprocs, ierr)
    CALL MPI_COMM_RANK(MPI_COMM_WORLD, mynode, ierr)

    ! ν
    IF( mynode == root ) THEN
       DO i = 1, N
          a(i) = i + i*100
       END DO
    END IF
    
    ! ¿ĹΥ֥ɥ㥹
    CALL bcast(a, N, root)

    !  㤨СΡ 0 Ǽͤɽ
    IF ( mynode == 0 ) THEN
       DO i = 1, N
          WRITE(*,*) exflib_double(a(i))
       END DO
    END IF

    ! λ
    CALL MPI_Finalize(ierr)

  !----------------------------------------------------------------------
  CONTAINS
  !----------------------------------------------------------------------

    SUBROUTINE bcast(v, length, root_node)

      TYPE(exfloat), DIMENSION(1:), INTENT(INOUT) :: v
      INTEGER*4, INTENT(IN) :: length, root_node
 
      INTEGER*4 :: mynode

      ! ¿ĹѥХåե
      INTEGER*8, DIMENSION(:), ALLOCATABLE :: buf
      INTEGER*4 :: bufsize
      INTEGER*4 :: ierr, s, i

      bufsize = exflib_exfloat_size * length
      ALLOCATE(buf(bufsize))

      CALL MPI_COMM_RANK(MPI_COMM_WORLD, mynode, ierr)

      ! packing
      IF (mynode == root_node) THEN
         DO i = 1, length
            DO s = 0, exflib_exfloat_size-1
               buf(exflib_exfloat_size*(i-1) + s) = v(i)%num(s)
            END DO
         END DO
      END IF

      ! communicating
      CALL MPI_BCAST(buf, bufsize, MPI_REAL8, root_node, MPI_COMM_WORLD, ierr)

      ! unpack
      IF (mynode /= root_node) THEN
         DO i = 1, length
            DO s = 0, exflib_exfloat_size-1
               v(i)%num(s) = buf(exflib_exfloat_size*(i-1) + s)
            END DO
         END DO
      END IF
      
      DEALLOCATE(buf)

    END SUBROUTINE bcast
    
END PROGRAM main

! End of file
