! -*- f90 -*-
! Time-stamp: "2006-04-11 12:28:28 t50523"
! $Id$

!----------------------------------------------------------------------
!  sample of MPI (Gather) program with exfloat
!
!  Copyright (C) 2006, FUJIWARA Hiroshi
!        <fujiwara@acs.i.kyoto-u.ac.jp>
!----------------------------------------------------------------------

PROGRAM main

    USE exflib
    IMPLICIT NONE
    INCLUDE 'mpif.h'

    ! ǤϥΡ 0 ˽
    INTEGER*4, PARAMETER :: root = 0

    ! 뤿Υǡ
    INTEGER*4, PARAMETER :: N = 5
    TYPE(exfloat) :: a(1:N)
    TYPE(exfloat), DIMENSION(:), ALLOCATABLE :: dst

    INTEGER*4 :: numprocs, mynode, ierr, i, r

    ! ʤ
    CALL MPI_INIT(ierr)
    CALL MPI_COMM_SIZE(MPI_COMM_WORLD, numprocs, ierr)
    CALL MPI_COMM_RANK(MPI_COMM_WORLD, mynode, ierr)
    
    ! 줾ν
    DO i = 1, N
       a(i) = i + mynode*100
    END DO
    ALLOCATE(dst(1:N*numprocs))

    CALL gather(a, dst, N, root)

    ! ǧΤὸ᤿ǡɽ
    IF( mynode == root ) THEN
       DO r = 0, numprocs-1
          DO i = 1, N
             WRITE(*,*) i, exflib_double(dst(r*N + i))
          END DO
       END DO
    END IF

    DEALLOCATE(dst)

    !------------------------------------------------------------
    ! λ
    !------------------------------------------------------------
    CALL MPI_Finalize(ierr)

  !----------------------------------------------------------------------
  CONTAINS
  !----------------------------------------------------------------------

    SUBROUTINE gather(src, dst, length, root_node)

      TYPE(exfloat), DIMENSION(1:), INTENT(IN) :: src
      TYPE(exfloat), DIMENSION(1:), INTENT(OUT) :: dst
      INTEGER*4, INTENT(IN) :: length, root_node

      INTEGER*4 :: numprocs
      INTEGER*4 :: i, r, s, ierr

      !----------------------------------------
      ! ¿ĹѥХåե
      !----------------------------------------
      INTEGER*8, DIMENSION(:), ALLOCATABLE :: sbuf, rbuf
      INTEGER*4 :: size 

      size = exflib_exfloat_size * length
      CALL MPI_COMM_SIZE(MPI_COMM_WORLD, numprocs, ierr)
      ALLOCATE(sbuf(0:size-1))
      ALLOCATE(rbuf(0:size*numprocs-1))

      ! packing
      DO i = 1, length
         DO s = 0, exflib_exfloat_size-1
            sbuf((i-1)*exflib_exfloat_size + s) = src(i)%num(s)
         END DO
      END DO

      ! communicating
      CALL MPI_GATHER(sbuf(0), size, MPI_REAL8, rbuf(0), size, MPI_REAL8, root_node, MPI_COMM_WORLD, ierr)

      ! unpacking
      IF ( mynode == root_node ) THEN
         DO r = 0, numprocs-1
            DO i = 1, length
               DO s = 0, exflib_exfloat_size-1

                  dst(r*length+i)%num(s) = rbuf((r*length+i-1)*exflib_exfloat_size+s)

               END DO
            END DO
         END DO
      END IF
      
      DEALLOCATE(sbuf)
      DEALLOCATE(rbuf)

    END SUBROUTINE gather

END PROGRAM main

! End of file
