! -*- f90 -*-
! Time-stamp: "2006-04-12 01:08:38 fujiwara"
! $Id$
!----------------------------------------------------------------------
!  sample of MPI (Reduce, finding maximum with index) program with exfloat
!
!  Copyright (C) 2006, FUJIWARA Hiroshi
!        <fujiwara@acs.i.kyoto-u.ac.jp>
!----------------------------------------------------------------------

!----------------------------------------------------------------------
! 黻ؿ : ͤθտ魯륤ǥå
!----------------------------------------------------------------------
SUBROUTINE exflib_lt_loc(inbuf, outbuf, length, type)

    USE exflib
    IMPLICIT NONE

    INTEGER*8, DIMENSION(0:exflib_exfloat_size-1), INTENT(IN) :: inbuf
    INTEGER*8, DIMENSION(0:exflib_exfloat_size-1), INTENT(INOUT) :: outbuf
    INTEGER*4, INTENT(IN) :: length, type

    TYPE(exfloat) :: in_val, out_val
    INTEGER*4 :: i

    ! pack
    DO i = 0, exflib_exfloat_size-1
       in_val%num(i) = inbuf(i+1)
       out_val%num(i) = outbuf(i+1)
    END DO
  
    ! 黻
    ! out < in ʤ顢out  in ˽񤭴
    IF ( out_val < in_val ) THEN
       DO i = 0, exflib_exfloat_size-1
          outbuf(i) = inbuf(i)
       END DO
    END IF

END SUBROUTINE exflib_lt_loc

!----------------------------------------------------------------------
PROGRAM main

    USE exflib
    IMPLICIT NONE
    INCLUDE 'mpif.h'

    ! ʬ黻ؿ
    INTERFACE
       SUBROUTINE exflib_lt_loc(invec, inoutvec, len, type)
         INTEGER*8, DIMENSION(0:), INTENT(IN) :: invec
         INTEGER*8, DIMENSION(0:), INTENT(INOUT) :: inoutvec
         INTEGER*4, INTENT(IN) :: len, type
       END SUBROUTINE exflib_lt_loc
    END INTERFACE

    INTEGER*4 :: numprocs, myproc, ierr
    INTEGER*4 :: exflib_maxloc
    
    ! ΥץǤϡƥΡɤ¿Ĺ x ͤ¤
    ! Ρ root (= 0)  sum ˽
    INTEGER*4, PARAMETER :: root = 0
    TYPE(exfloat) :: x, maximum
    INTEGER*4 :: index
    
    ! ʤ
    CALL MPI_INIT(ierr)
    CALL MPI_COMM_SIZE(MPI_COMM_WORLD, numprocs, ierr)
    CALL MPI_COMM_RANK(MPI_COMM_WORLD, myproc, ierr)

    ! 黻ؿϿ
    CALL MPI_OP_CREATE(exflib_lt_loc, .TRUE., exflib_maxloc, ierr)

    ! 줾ΥΡɤǤ
    x = 1
    x = x / (myproc+1)

    ! 黻̿
    CALL reduce(x, myproc, maximum, index, exflib_maxloc, root)

    ! ̤γǧ
    IF ( myproc == root ) THEN
       WRITE(*,*) index, exflib_double(maximum)
    END IF
    
    ! λ
    CALL MPI_Finalize(ierr)

  CONTAINS

    !----------------------------------------------------------------------
    !  Reduce ؿ
    !  ¿Ĺ 1 Ĥȡտ魯륤ǥå黻оݤȤ
    !  *src_elem, *src_index  &function ܤ̤root ˽󤹤
    !  root  res, res_index ̤ˤʤ
    !
    !  src_elem  : 黻оݤ¿Ĺ
    !  src_index : src_elem տ魯륤ǥå
    !  res_elem  : 黻̤Ǽ¿Ĺ
    !  res_index : 黻̤οտ魯륤ǥå
    !  function  : 黻
    !  root      : 黻 (res) ݻΡɤֹ
    !----------------------------------------------------------------------
    SUBROUTINE reduce(src_elem, src_index, res_elem, res_index, &
         func, root_node)

      TYPE(exfloat), INTENT(IN) :: src_elem
      INTEGER*4,     INTENT(IN) :: src_index, func, root_node
      TYPE(exfloat), INTENT(INOUT) :: res_elem
      INTEGER*4,     INTENT(OUT) :: res_index

      INTEGER*8, DIMENSION(:), ALLOCATABLE :: sbuf, rbuf

      INTEGER*4 :: bufsize, i
      bufsize = exflib_exfloat_size+1

      ! packing
      ALLOCATE(sbuf(0:bufsize))
      ALLOCATE(rbuf(0:bufsize))
      sbuf(0) = src_index
      DO i = 1, exflib_exfloat_size
         sbuf(i) = src_elem%num(i-1)
      END DO

      ! ̿
      CALL MPI_REDUCE(sbuf(0), rbuf(0), bufsize, &
           MPI_REAL8, func, root_node, &
           MPI_COMM_WORLD, ierr)

      ! unpacking
      res_index = rbuf(0)
      DO i = 1, exflib_exfloat_size
         res_elem%num(i-1) = rbuf(i)
      END DO

      DEALLOCATE(sbuf)
      DEALLOCATE(rbuf)

    END SUBROUTINE reduce

END PROGRAM main

! End of file
