// -*- C++ -*-
// Time-stamp: "2006-04-11 23:55:44 fujiwara"
// $Id$

//----------------------------------------------------------------------
//  sample of MPI (Reduce with SUM) program with exfloat
//
//  Copyright (C) 2006, FUJIWARA Hiroshi
//        <fujiwara@acs.i.kyoto-u.ac.jp>
//----------------------------------------------------------------------

#define PRECISION 100
#include "exfloat.h"

#include <iostream>
#include "mpi.h"
using namespace std;

//----------------------------------------------------------------------
// 黻ؿ : 
//----------------------------------------------------------------------

void exflib_add2(const void *inbuf, void *outbuf,
		 const int length, const MPI::Datatype& type)
{
    exflib_cuQword *in = reinterpret_cast<exflib_cuQword*>(inbuf);
    exflib_uQword *out = reinterpret_cast<exflib_uQword *>(outbuf);

#if 0
    // 1ʸǤϴݤޤޤʤ
    exflib_float_add(out, in, out, exfloat::precision64);
#endif

    // ¿Ĺ᤹
    exfloat in_val, out_val;
    for(long i = 0; i < exfloat::size; i++){
	in_val.num[i] = in[i];
	out_val.num[i] = out[i];
    }
    // 黻ȴݤ
    out_val += in_val;

    // Хåե᤹
    for(long i = 0; i < exfloat::size; i++)
	out[i] = out_val.num[i];

    return;
}

//----------------------------------------------------------------------
//  Reduce ؿ
//  ¿Ĺ 1 Ĥ黻оݤȤ
//  *src  &function ܤ̤root ˽󤹤
//  root  result ̤ˤʤ
//----------------------------------------------------------------------

void reduce(const exfloat *src, exfloat *result, MPI::Op &function,
	    const long root)
{
    // communication & operation
    MPI::COMM_WORLD.Reduce((*src).num, (*result).num,
			   exfloat::size, MPI::DOUBLE, function, root);
    return;
}

//----------------------------------------------------------------------
// main routine
//----------------------------------------------------------------------
int main(int argc, char *argv[])
{
    MPI::Init(argc, argv);
    const long numprocs = MPI::COMM_WORLD.Get_size();
    const long myproc   = MPI::COMM_WORLD.Get_rank();

    // ΥץǤϡƥΡɤ¿Ĺ x ͤ¤
    // Ρ root (= 0)  sum ˵
    exfloat x = myproc;
    exfloat sum;
    const long root = 0;

    // 黻Ͽ
    MPI::Op exflib_sum;
    exflib_sum.Init(exflib_add2, true);

    // 黻
    reduce(&x, &sum, exflib_sum, root);

    // ̤ɽ
    if(myproc == root)
	cout << sum << endl;

    MPI::Finalize();
    return 0;
}

// End of file
