! -*- f90 -*-
! Time-stamp: "2006-04-12 01:07:48 fujiwara"
! $Id$
!----------------------------------------------------------------------
!  sample of MPI (Reduce with SUM) program with exfloat
!
!  Copyright (C) 2006, FUJIWARA Hiroshi
!        <fujiwara@acs.i.kyoto-u.ac.jp>
!----------------------------------------------------------------------

!----------------------------------------------------------------------
! 黻ؿ
!----------------------------------------------------------------------
SUBROUTINE exflib_add2(inbuf, outbuf, length, type)

    USE exflib
    IMPLICIT NONE

    INTEGER*8, DIMENSION(0:exflib_exfloat_size-1), INTENT(IN) :: inbuf
    INTEGER*8, DIMENSION(0:exflib_exfloat_size-1), INTENT(INOUT) :: outbuf
    INTEGER*4, INTENT(IN) :: length, type

    TYPE(exfloat) :: in_val, out_val
    INTEGER*4 :: i

    ! pack
    DO i = 0, exflib_exfloat_size-1
       in_val%num(i) = inbuf(i)
       out_val%num(i) = outbuf(i)
    END DO
  
    ! 黻 (ݤ⤪ʤ)
    out_val = out_val + in_val

    ! unpack
    DO i = 0, exflib_exfloat_size-1
       outbuf(i) = out_val%num(i)
    END DO
    
END SUBROUTINE exflib_add2

!----------------------------------------------------------------------

PROGRAM main

    USE exflib
    IMPLICIT NONE
    INCLUDE 'mpif.h'

    ! ʬ黻ؿ
    INTERFACE
       SUBROUTINE exflib_add2(invec, inoutvec, len, type)
         INTEGER*8, DIMENSION(0:), INTENT(IN) :: invec
         INTEGER*8, DIMENSION(0:), INTENT(INOUT) :: inoutvec
         INTEGER*4, INTENT(IN) :: len, type
       END SUBROUTINE exflib_add2
    END INTERFACE

    INTEGER*4 :: numprocs, mynode, ierr
    INTEGER*4 :: exflib_sum

    ! ΥץǤϡƥΡɤ¿Ĺ x ͤ¤
    ! Ρ root (= 0)  sum ˽
    TYPE(exfloat) :: x, sum
    INTEGER*4, PARAMETER :: root = 0

    ! ʤ
    CALL MPI_INIT(ierr)
    CALL MPI_COMM_SIZE(MPI_COMM_WORLD, numprocs, ierr)
    CALL MPI_COMM_RANK(MPI_COMM_WORLD, mynode, ierr)

    ! 黻ؿϿ
    CALL MPI_OP_CREATE(exflib_add2, .TRUE., exflib_sum, ierr)

    ! 줾ΥΡɤǡͤ
    x = mynode

    ! 黻̿
    CALL reduce(x, sum, exflib_sum, root)

    ! ̤γǧ
    IF ( mynode == root ) THEN
       WRITE(*,*) exflib_double(sum)
    END IF

    ! λ
    CALL MPI_Finalize(ierr)

  CONTAINS

    !------------------------------------------------------------
    ! Reduce
    !------------------------------------------------------------
    SUBROUTINE reduce(src, res, func, root_node)

      TYPE(exfloat), INTENT(IN) :: src
      TYPE(exfloat), INTENT(OUT) :: res
      INTEGER*4, INTENT(IN) :: func, root_node
      INTEGER*4 :: ierr

      INTEGER*4 :: loc_size
      loc_size = exflib_exfloat_size

      CALL MPI_REDUCE(src%num(0), res%num(0), loc_size, &
           MPI_REAL8, func, root_node, &
           MPI_COMM_WORLD, ierr)

    END SUBROUTINE reduce

END PROGRAM main

! End of file
