// -*- C++ -*-
// Time-stamp: "2006-04-09 11:04:20 fujiwara"
// $Id$

//----------------------------------------------------------------------
//  sample of OpenMP program with exfloat
//
//  Copyright (C) 2006, FUJIWARA Hiroshi
//        <fujiwara@acs.i.kyoto-u.ac.jp>
//----------------------------------------------------------------------

#define PRECISION 100
#include "exfloat.h"

#include <iostream>

#ifdef _OPENMP
#include <omp.h>
#endif

using namespace std;

int main()
{
    int mythread, nthreads;
    exfloat x = 1;
    const long N = 10;
    exfloat a[N];

    //------------------------------------------------------------
    // Ū
    //------------------------------------------------------------
    omp_set_num_threads(2);

    // private ѿ parallel κǽǤϽƤʤ
    // firstprivate ѿϡ༡¹ͤǽ
    #pragma omp parallel private(mythread, nthreads) firstprivate (x)
    {
	mythread = omp_get_thread_num();
	nthreads = omp_get_num_threads();

	cout << "ThreadID " << mythread << " of " << nthreads << endl;
	cout << "first private value = " << x << " is changed to ";	
	x += mythread;
	cout << x << " on thread " << mythread << endl;
    }

    //------------------------------------------------------------
    // ֥åʬ
    //------------------------------------------------------------
    #pragma omp parallel for
    for(long i = 0; i < N; i++)
	a[i] = static_cast<exfloat>(omp_get_thread_num());

    for(long i = 0; i < N; i++)
	cout << a[i] << ' ';
    cout << endl;

    //------------------------------------------------------------
    // 1 ĤĳƤ (åʬ)
    //------------------------------------------------------------
    #pragma omp parallel for schedule(static, 1)
    for(long i = 0; i < N; i++)
	a[i] = static_cast<exfloat>(omp_get_thread_num());
    
    for(long i = 0; i < N; i++)
	cout << a[i] << ' ';
    cout << endl;

    //------------------------------------------------------------
    // ưŪˡץ˳Ƥ
    //------------------------------------------------------------
    #pragma omp parallel for schedule(dynamic)
    for(long i = 0; i < N; i++)
	a[i] = static_cast<exfloat>(omp_get_thread_num());
    
    for(long i = 0; i < N; i++)
	cout << a[i] << ' ';
    cout << endl;

#if 0
    //------------------------------------------------------------
    // reduction ǥ쥯ƥ֤ǻǤѿϡ
    // Ȥ߹ߤδ췿餷
    // ¡ѡ͡Ǿͤθ reduction ϻȤʤ
    //------------------------------------------------------------
    exfloat sum = 0;
    #pragma omp parallel for reduction (+:sum)
    for(long i = 0; i < N; i++)
	sum += a[i];

    cout << "sum : " << sum << endl;
#endif

    //------------------------------------------------------------
    return 0;
}

// End of file
