! -*- f90 -*-
! Time-stamp: "2006-04-09 12:10:02 fujiwara"
! $Id$

!----------------------------------------------------------------------
!  sample of OpenMP program with exfloat
!
!  Copyright (C) 2006, FUJIWARA Hiroshi
!        <fujiwara@acs.i.kyoto-u.ac.jp>
!----------------------------------------------------------------------

PROGRAM main

    USE exflib
    IMPLICIT NONE
    INTEGER OMP_GET_NUM_THREADS
    INTEGER OMP_GET_THREAD_NUM

    INTEGER :: mythread, nthreads
    INTEGER, PARAMETER :: N = 10
    TYPE(exfloat) :: a(N), sum

    INTEGER :: i

    !--------------------------------------------------
    ! Ū
    !--------------------------------------------------
    CALL OMP_SET_NUM_THREADS(2)

    !$OMP PARALLEL PRIVATE(mythread, nthreads)
    nthreads = OMP_GET_NUM_THREADS()
    mythread = OMP_GET_THREAD_NUM()
    WRITE(*,*) 'ThreadID : ', mythread, ' of ', nthreads
    !$OMP END PARALLEL

    !--------------------------------------------------
    ! ֥åʬ
    !--------------------------------------------------
    !$OMP PARALLEL DO
    DO i = 1, N
       a(i) = OMP_GET_THREAD_NUM()
    END DO
    !$OMP END PARALLEL DO

    DO i = 1, N
       WRITE(*,*) exflib_double(a(i))
    END DO
    WRITE(*,*)
  
    !--------------------------------------------------
    ! 1 ĤĳƤ (åʬ)
    !--------------------------------------------------
    !$OMP PARALLEL DO SCHEDULE (STATIC, 1)
    DO i = 1, N
       a(i) = OMP_GET_THREAD_NUM()
    END DO
    !$OMP END PARALLEL DO

    DO i = 1, N
       WRITE(*,*) exflib_double(a(i))
    END DO
    WRITE(*,*)

    !--------------------------------------------------
    ! ưŪˡץ˳Ƥ
    !--------------------------------------------------
    !$OMP PARALLEL DO SCHEDULE (DYNAMIC)
    DO i = 1, N
       a(i) = OMP_GET_THREAD_NUM()
    END DO
    !$OMP END PARALLEL DO

    DO i = 1, N
       WRITE(*,*) exflib_double(a(i))
    END DO
    WRITE(*,*)

!    !--------------------------------------------------
!    ! ¤Ȥ
!    !--------------------------------------------------
!    sum = 0
!    !$OMP PARALLEL DO REDUCTION(+:sum)
!    DO i = 1, N
!       sum = sum + a(i)
!    END DO
!    !$OMP END PARALLEL DO
!
!    WRITE(*,*) sum

END PROGRAM main

! End of file
