/*
 * Complile PGI : pgCC -O0 -o omp_vector omp_vector.cpp -mp libexfloat.a
 * Complile GNU : g++ -m32 -O0 -o omp_vector omp_vector.cpp -fopenmp libexfloat.a
 *
 */


#define PRECISION 200
#include "exfloat.h"

#include <iostream>
#include <complex>
#include <omp.h>

using namespace std;

#define N 4

#define sce static_cast<exfloat> 

int main(void)
{
  int i,j;
  complex<double> d_a[N][N];
  complex<double> d_b[N];
  complex<double> d_c[N];

  complex<exfloat> e_a[N][N];
  complex<exfloat> e_b[N];
  complex<exfloat> e_c[N];
  
  for(i=0;i<N;i++){
    for(j=0;j<N;j++){
      d_a[i][j]=complex<double>(j+1,0);
      e_a[i][j]=complex<exfloat>(sce(j+1),sce(0));
    }
    d_b[i]=complex<double>(double(1)/(i+1),0);
    e_b[i]=complex<exfloat>(sce(1)/sce(i+1),sce(0));
  }  

  /*
  for(i=0;i<N;i++){
    for(j=0;j<N;j++){
      cout<< e_a[i][j];
    }
    cout<<endl;
  }
  cout<<endl;
  
  for(i=0;i<N;i++)
    cout<< e_b[i] <<endl;
  cout<<endl;
  */

#pragma omp parallel for private(i,j)
    for(i=0;i<N;i++){

	cout << omp_get_thread_num() << endl;

      d_c[i]=complex<double>(0,0);
      e_c[i]=complex<exfloat>(0,0);
      for(j=0;j<N;j++){
	d_c[i]+=d_a[i][j]*d_b[j];
	e_c[i]+=e_a[i][j]*e_b[j];
      }
      //printf("hello from thread id %d/%d\n",
      //     omp_get_thread_num()+1,omp_get_num_threads());
    }
    
    cout << "double_complex c[] :" << endl;
    for(i=0;i<N;i++)
      cout<< d_c[i] <<endl;
    cout<<endl;
 
    cout << "exflib_complex c[] :" <<endl;
    for(i=0;i<N;i++)
      cout<< e_c[i] << endl;
    cout<<endl;
 
  return 0;
}
